﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using FDAL.Database;

namespace FDAL.Gen
{
    public class TMiscGenerator
    {
        private const string SP_SCHEMA = "KDAL_SP";
        private TDatabaseExplorer explorer;

        public TMiscGenerator(SqlConnection conn)
        {
            this.explorer = new TDatabaseExplorer(conn);
        }

        public string Generate()
        {
            TCodeWriter writer = new TCodeWriter();
            List<TSchema> schemaList = explorer.GetSchemas();
            bool exists = schemaList.Where<TSchema>(sc => sc.Name == SP_SCHEMA).Count<TSchema>() == 1;
            if (!exists)
            {
                writer.WriteLineFormat("CREATE SCHEMA {0};", SP_SCHEMA);
            } else {
                List<TStoredProcedure> procs = explorer.GetStoredProceduresBySchema(SP_SCHEMA);
                foreach (TStoredProcedure proc in procs)
                {
                    //writer.WriteLineFormat("DROP PROCEDURE"
                }
            }

            return writer.Code;
        }
    }
}
