﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;

namespace FDAL.Gen
{
    public class TTableGenerator
    {
        private TCodeWriter writer;

        public TTableGenerator()
        {
            this.writer = new TCodeWriter();
        }


        public string GetColumnDefString(PropertyInfo pi)
        {
            string defString = null;
            string cname = pi.Name;
            string ctype = TypeMapper.GetDBType(pi.PropertyType);
            if (ctype != null)
            {
                defString = string.Format("[{0}] {1}", cname, ctype);
            }
            return defString;
        }

        public string GenerateSqlCreate(Type type)
        {
            string tableName = string.Format("[{0}]", type.Name);
            writer.WriteLineFormat("CREATE TABLE {0} (", tableName);
            writer.PushIdent();
            List<string> colDefsList = new List<string>();
            PropertyInfo[] pis = type.GetProperties();
            for (int i = 0; i < pis.Length; i++)
            {
                string colDefString = GetColumnDefString(pis[i]);
                if (colDefString != null)
                {
                    writer.Write(colDefString);
                    if (i < pis.Length - 1)
                    {
                        writer.WriteLineNoIdent(",");
                    }
                }
            }
            writer.PopIdent();
            writer.WriteLine();
            writer.Write(");");

            return writer.Code;
        }
    }
}
