﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.IO;
using System.Xml;
using System.Xml.Linq;

namespace FDAL
{
    internal class StatementStore
    {
        IDictionary<string, string> dic;
        private static StatementStore instance;

        private StatementStore()
        {
            dic = new Dictionary<string, string>();
        }

        private void load()
        {
            Assembly assembly = Assembly.GetExecutingAssembly();
            var resourceName = "FDAL.Lib.sql.xml";
            using (Stream stream = assembly.GetManifestResourceStream(resourceName))
            {
                XDocument doc = XDocument.Load(stream);
                IEnumerable<XElement> statements = doc.Elements();
                
                foreach (var statement in statements.Elements())
                {
                    string id = statement.Element("id").Value.Trim();
                    string content = statement.Element("content").Value.Trim();
                    dic[id] = content; 
                }
            }
        }

        public static StatementStore GetInstance()
        {
            if (instance == null)
            {
                instance = new StatementStore();
                instance.load();
            }
            return instance;
        }

        public string GetStatement(string id)
        {
            string s = dic[id];
            return s;
        }
    }
}
